<p-panel styleClass="recipe-panel" header="Recipes">
  <p-table
    #recipesTable
    *ngIf="recipes"
    [value]="recipes"
    [globalFilterFields]="['authorUser.email']"
  >
    <ng-template pTemplate="caption">
      <p-dropdown
        [options]="authors"
        [(ngModel)]="selectedAuthor"
        (onChange)="
          recipesTable.filter(selectedAuthor, 'authorUser.email', 'equals')
        "
        placeholder="Select an author's email to filter out recipes..."
      ></p-dropdown>

      <button
        pButton
        label="Clear"
        class="p-button-outlined"
        icon="pi pi-filter-slash"
        (click)="clear(recipesTable)"
      ></button>
    </ng-template>
    <ng-template pTemplate="header">
      <tr>
        <th>Appliance</th>
        <th>Author</th>
        <th>Ingredients</th>
        <th>Name</th>
        <th>Time to Make</th>
        <th>Instructions</th>
        <th>Portions</th>
        <th></th>
        <th></th>
      </tr>
    </ng-template>
    <ng-template pTemplate="body" let-recipe>
      <tr>
        <td>{{ recipe.appliance }}</td>

        <td *ngIf="recipe.authorUser">
          {{ recipe.authorUser.firstName }} {{ recipe.authorUser.lastName }} ({{
            recipe.authorUser.email
          }})
        </td>
        <td *ngIf="!recipe.authorUser"></td>
        <td>{{ convertIngredientsToString(recipe.ingredients) }}</td>
        <td>{{ recipe.name }}</td>
        <td>{{ recipe.timeToMake }}</td>
        <td>{{ recipe.instructions }}</td>
        <td>{{ recipe.portions }}</td>
        <td>
          <button pButton (click)="showAddEdit(recipe)" label="Edit"></button>
        </td>
        <td>
          <button
            pButton
            (click)="deleteRecipe(recipe)"
            label="Delete"
          ></button>
        </td>
      </tr>
    </ng-template>
  </p-table>

  <recipe-addedit
    [display]="displayAddEdit"
    [recipe]="selectedRecipe"
    [edit]="edit"
    (itemSaved)="closeAddEdit($event)"
  ></recipe-addedit>
  <hr />
  <button pButton (click)="showAddEdit()" label="New Recipe"></button>
</p-panel>
